<?PHP

/* ====================
[BEGIN_SED_EXTPLUGIN]
Code=rssreader
Part=main
File=rssreader
Hooks=index.tags
Tags=
Order=10
[END_SED_EXTPLUGIN]
==================== */

/**
 * RSS Reader (read and parse rss from other sites)
 *
 * @package Cotonti
 * @version 1.00
 * @author Seditio.by
 * @copyright Copyright (c) Seditio.by 2009
 */

if (!defined('SED_CODE'))
{ die('Wrong URL.'); }

require_once $cfg['plugins_dir'].'/rssreader/inc/lastrss.php';

function sed_rss_parse($rss_url, $rss_count, $skinfile, $charset="UTF-8", $htmlsave=1)
{
    global $cfg;
    if(mb_strpos($rss_url, 'http://') !== 0)
    {
        $rss_url='http://'. $rss_url;
    }
    $jj=0;

    if(file_exists(sed_skinfile($skinfile, true)))
    {
        $readrss = new XTemplate(sed_skinfile($skinfile, true));
    }
    else
    {
        $readrss = new XTemplate(sed_skinfile('rssreader', true));
    }

    // create lastRSS object
    $rss = new lastRSS;

    // setup transparent cache
    $rss->cache_dir = $cfg['cache_dir'];
    $rss->cache_time = 14400;
    $rss->items_limit =$rss_count;
    $rss->date_format=$cfg['formatyearmonthday'];
    if(!$htmlsave)
    {$rss->stripHTML=true;}
    else
    {$rss->stripHTML=false;}
    $rss->cp = 'UTF-8';
    $rss->default_cp=$charset;
    $rss->CDATA="content";
    // load some RSS file
    if ($rs = $rss->get($rss_url))
    {
        if ($rs[image_url] != '')
        {
            $rss_image = "<a href=\"$rs[image_link]\"><img src=\"$rs[image_url]\" alt=\"$rs[image_title]\" vspace=\"1\" border=\"0\" /></a>";
        }

        foreach ($rs['items'] as $item)
        {
            $jj++;
            $readrss -> assign(array(
                "RSS_LINK" => $item[link],
                "RSS_TITLE" => $item['title'],
                "RSS_DATE" => $item['pubDate'],
                "RSS_DESCRIPTION" => $item['description'],
                "RSS_CAT" => $item['category'],
                "RSS_COMMENTS" => $item['comments'],
                "RSS_ENCLOSURE" => $item['enclosure'],
                "RSS_GUID" => $item['guid'],
                "RSS_SUORCE" => $item['source'],
                "RSS_ODDEVEN" => sed_build_oddeven($jj),
                "RSS_NUM" => $jj,
            ));
            $readrss -> parse("MAIN.RSS_BLOCK");
        }
        $readrss -> assign(array(
            "RSS_INFO_LINK" => $rs['link'],
            "RSS_INFO_DESC" => $rs['title'],
            "RSS_INFO_IMAGE" => $rss_image,
            "RSS_INFO_DESC" => $rs['description']
        ));

    }
    else
    {
        $readrss -> parse("MAIN.ERROR");
    }

    $readrss -> parse("MAIN");

    return $readrss -> text("MAIN");
}

$categories = explode("\n", $cfg['plugin']['rssreader']['category']);

foreach($categories as $k => $v)
{
    $v=trim($v);
    $v = explode('|', $v);

    if (!empty($v[0]) && !empty($v[1]) && (int)$v[2]>0)
    {
        $t-> assign("RSS_".strtoupper($v[0]), sed_rss_parse($v[1], $v[2], 'rssreader.'.$v[0].'.tpl', $v[3], $v[4]));
    }

}

?>